
// si vous voulez que la premire mozaque soit toujours un
// carr noir : initialisee ind non pas  0 mais  1.


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <mem.h>
#include <allegro.h>

// valeur par dfaut du nombre de mozaques par ligne
// (image de fin)
#define DEF_IND_MOZ 20

// taille d'une mozaque
#define TAILLE_MOZ 8

/* variables globales

   image    : image source  analyser
   mozaique : contient les mozaiques trouves.
   sub_bmp  : sub-bitmap de mozaique : pour ne sauvegarder que l'essentiel
   fic_bin  : fichier CODAGE.BIN
   counter  : nombre de secondes coules
   buffer[] : une ligne d'indice de l'image source
*/

BITMAP * image = NULL, * mozaique = NULL, * sub_bmp = NULL;
FILE   * fic_bin = NULL;
volatile unsigned long counter = 0;
unsigned short int buffer[50000];



// pour chronomtrer le temps que prend l'analyse
void mesure_temps(void)
{
   counter++;
}
END_OF_FUNCTION(mesure_temps);

// dbut programme
void main(int argc, char * argv[])
{
   PALETTE palette;
   unsigned short int x, y, x2, y2, i, l, c, ind=0, nb_ind_moz = DEF_IND_MOZ,
                      nb_pix, deb_x = 0;
   short int trouve, sens_x = TAILLE_MOZ, chrono = TRUE, hh, mm, ss, buff_ind;
   enum {NORMALE, ENVERS} analyse = NORMALE;

   if (argc == 1)
   {
      nb_pix = TAILLE_MOZ * nb_ind_moz;
      printf("=== MAKEMOZ, Par Paul SIRAMY, le 21/04/1999. Freeware ===\n\n"
             "Syntaxe : MAKEMOZ IMAGE.EXT [n] [-r]\n"
             "   IMAGE.EXT : Une image de multiple x pixels en longueur et hauteur\n"
             "                L'image des mozaques sera en 256 couleurs au final\n"
             "                Formats reconnus : BMP LBM PCX TGA\n"
             "   n : nb de mozaques dans une ligne du fichier MOZAIQUE.PCX (dfaut <%i>)\n"
             "  -r : le programme analyse de droite  gauche, pour que les mozaques\n"
             "       dans le fichier MOZAIQUE.PCX se distinguent mieux.\n\n"
             "Ce programme cre deux fichiers : CODAGE.BIN et MOZAIQUE.PCX. Il analyse\n"
             "d'abord de gauche  droite la premire ligne de l'image (sauf si option -r) et\n"
             "il en dduit les mozaques uniques. Il passe ensuite aux lignes suivantes et\n"
             "procde de mme.\n\n"
             "Le fichier CODAGE.BIN n'est qu'une suite d'indices de mozaques codes sur 2\n"
             "octets de type Unsigned. Octet de poid faible d'abord, octet de poid fort\n"
             "ensuite. Les 2 premiers octets sont le nombre de mozaques horizontales !!!\n\n"
             "Les mozaques trouves sont inscrites dans MOZAIQUE.PCX de la mme faon :\n"
             "D'abord la premire ligne, de gauche  droite. Puis on passe aux lignes\n"
             "suivantes. La longueur de l'image des mozaques  une longueur par dfaut\n"
             "de <%u> pixels. La hauteur est en fonction du nombre de mozaques.\n",
                DEF_IND_MOZ, nb_pix);
      exit(0);
   }
   if (__file_exists(argv[1]) == 0)
   {
      printf("Fichier <%s> inexistant\n", argv[1]);
      exit(1);
   }
   // paramtre -r ?
   i = 0;
   if (argc >= 3)
   {
      i = 2;
      if (stricmp("-r", argv[i]) == 0)
         analyse = ENVERS;
      else if (argc >= 4)
      {
         i = 3;
         if (stricmp("-r", argv[i]) == 0)
            analyse = ENVERS;
         else
            i = 0;
      }
   }
   // un nombre de mozaques ?
   if (argc >= 3)
   {
      y = 0;
      if (i != 0)
      {
         if (*argv[2] != '-')
            y  = 2;
      }
      else
      {
         if (i == 2 && argc >=4 && *argv[3] != '-')
            y = 3;
         else if (*argv[3] != '-')
            y = 2;
      }
      if (y != 0)
      {
         nb_ind_moz = atoi(argv[y]);
         if (nb_ind_moz == 0)
         {
            printf("Veuillez donner un nombre de mozaques suprieur  zro !\n");
            exit(1);
         }
      }
   }
   // inits
   nb_pix = TAILLE_MOZ * nb_ind_moz;
   allegro_init();
   install_keyboard();
   LOCK_VARIABLE(counter);
   LOCK_FUNCTION(mesure_temps);
   install_timer();
   if (install_int_ex(mesure_temps, MSEC_TO_TIMER(1000)) < 0)
   {
      printf("Chronomtre dsactiv\n");
      chrono = FALSE;
   }
   // charge image
   image = load_bitmap(argv[1], palette);
   if (image == NULL)
   {
      printf("Image impossible  ouvrir\n");
      exit(1);
   }
   // les dimensions de l'image sont-elles des multiples de TAILLE_MOZ ?
   if ((image->w % TAILLE_MOZ) + (image->h % TAILLE_MOZ) != 0)
   {
      if ((image->w % TAILLE_MOZ) != 0)
         printf("La longueur de l'image n'est pas un multiple de %u (%u)\n", TAILLE_MOZ, image->w);
      if ((image->h % TAILLE_MOZ) != 0)
         printf("La hauteur  de l'image n'est pas un multiple de %u (%u)\n", TAILLE_MOZ, image->h);
      destroy_bitmap(image);
      exit(1);
   }
   // quelques statistiques
   printf("Image source :\n");
   printf("    Dimensions : %u * %u = %u pixels\n", image->w, image->h,
      image->w * image->h);
   printf("    NB blocs   : %u * %u = %u mozaques\n", image->w/TAILLE_MOZ,
      image->h/TAILLE_MOZ, image->w * image->h / (TAILLE_MOZ*TAILLE_MOZ));
   printf("    Taille     : %u Ko\n", image->w * image->h / 1024);
   // cre une bitmap en mmoire pour stocker les mozaques.
   // Longueur : nb_pix pixels. Hauteur : ce qu'il faut pour que nb_pix * X
   // donne au moins la mme taille que l'original
   mozaique = create_bitmap(nb_pix, TAILLE_MOZ + (image->w * image->h) / nb_pix);
   clear(mozaique);
   // cre (ouvre) fichier binaire du codage de l'image
   fic_bin = fopen("CODAGE.BIN", "wb");
   if (fic_bin == NULL)
   {
      printf("CODAGE.BIN impossible  crer\n");
      destroy_bitmap(image);
      destroy_bitmap(mozaique);
      exit(1);
   }
   // nb mozaques sens horizontal
   i = image->w / TAILLE_MOZ;
   fwrite(&i, 2, 1, fic_bin);
   // sens de l'analyse
   if (analyse == ENVERS)
   {
      deb_x  = image->w - TAILLE_MOZ;
      sens_x = -TAILLE_MOZ;
   }
   // ca vas commencer
   printf("Sens d'analyse : ");
   if (analyse == NORMALE)
      printf("Normal\n");
   else
      printf("Envers\n");
   printf("Analyse en cours...\n");
   // dcompose l'image en mozaques
   for (y=0; y<image->h; y += TAILLE_MOZ)
   {
      if (analyse == NORMALE)
         buff_ind = 0;
      else
         buff_ind = image->w / TAILLE_MOZ - 1;
      memset(buffer, 0, sizeof(buffer));
      // astuce pour test boucle X :
      // en fin de dcrmentation, x = 0
      // a ce moment, x - TAILLE_MOZ devient suprieur  image->w puisque x est
      // de type UNSIGNED ! donc le test est bon
      for (x=deb_x; x<image->w; x += sens_x)
      {
         // cherche la mozaque identique
         trouve = FALSE;
         for (i=0; i<ind && trouve != TRUE; i++)
         {
            y2 = TAILLE_MOZ * (i/nb_ind_moz);
            x2 = TAILLE_MOZ * (i%nb_ind_moz);
            for (l=0; l<TAILLE_MOZ; l++)
            {
               for (c=0; c<TAILLE_MOZ; c++)
               {
                  if (image->line[y+l][x+c] != mozaique->line[y2+l][x2+c])
//                  if (getpixel(image, x+c, y+l) != getpixel(mozaique, x2+c, y2+l))
                  {
                     trouve = FALSE;
                     goto sortie; // c'est pas beau, mais c'est efficace
                  }
               }
            }
            trouve = TRUE;
            sortie :
         }
         // cre une nouvelle mozaque ?
         if (trouve == FALSE)
         {
            // ajoute une mozaque
            y2 = TAILLE_MOZ * (ind/nb_ind_moz);
            x2 = TAILLE_MOZ * (ind%nb_ind_moz);
            blit(image, mozaique, x, y, x2, y2, TAILLE_MOZ, TAILLE_MOZ);
            ind++;
         }
         // note l'indice
         if (trouve == TRUE)
            i--; // anti-bug
         buffer[buff_ind] = i;
         if (analyse == NORMALE)
            buff_ind++;
         else
            buff_ind--;
      }
      // crit une ligne d'indices de l'image source
      fwrite(buffer, 2, image->w / TAILLE_MOZ, fic_bin);
   }
   // analyse termine
   // cre une sub_bitmap pour ne garder que l'essentiel
   if (ind <= nb_ind_moz) // si on a qu'une ligne
   {
      x = ind*TAILLE_MOZ;
      y = TAILLE_MOZ;
   }
   else // cas gnral
   {
      x = nb_pix;
      y = TAILLE_MOZ * (ind/nb_ind_moz);
      if ((ind%nb_ind_moz) != 0)
         y += TAILLE_MOZ;
   }
   sub_bmp = create_sub_bitmap(mozaique, 0, 0, x, y);
   // sauve l'image contenant les mozaques trouves
   save_pcx("mozaique.pcx", sub_bmp, palette);


   // statistiques
   if (chrono == TRUE)
   {
      // dsactive le chrono : pour viter que la variable counter change
      // en plein millieu des calculs
      remove_int(mesure_temps);

/*
   // TEST du fichier CODAGE.BIN
   // ne pas oublier que les 2 premiers octets ne sont pas un indice !!
   fclose(fic_bin);
   fic_bin = fopen("codage.bin", "rb");
   fread(&i, 2, 1, fic_bin); // nb mozaques sens horizontal
   l = y;
   c = i * (TAILLE_MOZ + 1);
   printf("Nombre de mozaques dans le sens horizontal : %u\n", i);
   printf("Appuyez sur une touche...\n");
   readkey();
   set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0);
   set_palette(palette);
   nb_ind_moz = mozaique->w / TAILLE_MOZ;
   for (y=0; y < (image->h / TAILLE_MOZ) * (TAILLE_MOZ+1); y+=(TAILLE_MOZ+1))
   {
      for (x=0; x < c; x+= (TAILLE_MOZ + 1))
      {
         fread(&i, 2, 1, fic_bin);
         y2 = TAILLE_MOZ * (i / nb_ind_moz);
         x2 = TAILLE_MOZ * (i % nb_ind_moz);
         blit(mozaique, screen, x2, y2, x, y, TAILLE_MOZ, TAILLE_MOZ);
      }
   }
   readkey();
   set_gfx_mode(GFX_TEXT, 80, 25, 0, 0);
   y = l;
   // FIN_TEST
*/

      hh = counter / 3600;
      mm = (counter - 3600 * hh) / 60;
      ss = counter - 3600 * hh - 60 * mm;
      printf("Temps ncessaire :");
      if (counter==0)
         printf(" Moins d'une seconde");
      if (hh)
      {
         printf(" %i heure", hh);
         if (hh>1) printf("s");
      }
      if (mm)
      {
         printf(" %i minute", mm);
         if (mm>1) printf("s");
      }
      if (ss)
      {
         printf(" %i seconde", ss);
         if (ss>1) printf("s");
      }
      printf("\n");
   }
   printf("%u mozaques trouves\n", ind);
   printf("Image finale :\n");
   if (ind <= nb_ind_moz)
   {
      x = ind;
      y = 1;
   }
   else
   {
      x = nb_ind_moz;
      y /= TAILLE_MOZ;
   }
   printf("    Dimensions : %u * %u = %u pixels\n", TAILLE_MOZ*x, TAILLE_MOZ*y, (TAILLE_MOZ*TAILLE_MOZ)*x*y);
   printf("    NB blocs   : %u * %u = %u mozaques\n", x, y, x*y);
   printf("    Taille     : %u Ko\n", x*y/4);
   printf("Emplacements de mozaques inutiliss : ");
   if(ind <= nb_ind_moz)
      printf("0\n");
   else
      printf("%u\n", y*nb_ind_moz - ind);
   x = sizeof(unsigned short int) * (image->w/TAILLE_MOZ) * (image->h/TAILLE_MOZ) + 2;
   printf("CODAGE.BIN : %u octets", x);
   if (x >= 1024)
   {
      if ((x % 1024) >= 512)
         printf(" (%u Ko)", x / 1024 + 1);
      else
         printf(" (%u Ko)", x / 1024);
   }
   printf("\nNb de mozaques en longueur optimum : ");
   y = (unsigned short int) sqrt(ind) + 1;
   for (i=y; i>=1 && ind%i != 0; i--)
      ;
   if (i != 0)
      printf("%u\n", ind / i);
   else
      printf("?\n");
   printf("Pour obtenir  peu prs un carr    : %u\n", y);

   destroy_bitmap(image);
   destroy_bitmap(mozaique);
   destroy_bitmap(sub_bmp);
   fclose(fic_bin);
   exit(0);
}

